#INCLUDE "Topconn.ch"
#INCLUDE "Protheus.ch"

/*


ͻ
Programa  RESTRC01   Autor  Cludio Duarte   Data  27/07/16 		
͹
Desc. Impresso de relatrio de itens a fracionar em TReport simples. 
                                                                      
͹
Uso        				                                               
ͼ


*/
User Function RESTRC01() 

//Ŀ
//Declaracao de variaveis                   
//

Private oReport  := Nil
Private oSecCab	 := Nil
Private cPerg 	 := PadR ("RESTRC01", Len (SX1->X1_GRUPO))  // ALINHA A STRING AO TAMANHO DO X1_GRUPO

//Ŀ
//Criacao e apresentacao das perguntas      
// 

//O "c" depois de mv_ch3 e mv_ch4  a reposta do relat. que  texto, ou seja, o que aparee no relatrio, e no a informao
//que carrega na caixinha de seleo, l por exemplo recebe o cdigo do cliente que possui 6 digitos.

//PutSx1(cPerg,"01","Consultor?"            ,'','',"mv_ch1","C",TamSx3 ("Z9_CODCONS")[1] ,0,,"G","","SZ9","","S","mv_par01","","","","","","","","","","","","","","","","")
PutSx1(cPerg,"01","Data inicial?"         ,'','',"mv_ch1","D",8 ,0,0,"G","","","","S","mv_par01","","","","","","","","","","","","","","","","")
PutSx1(cPerg,"02","Data final?"           ,'','',"mv_ch2","D",8 ,0,0,"G","","","","S","mv_par02","","","","","","","","","","","","","","","","")
//PutSx1(cPerg,"03","Cliente de?"           ,'','',"mv_ch3","C",6,0,0,"G","","SZ9","","S","mv_par03","","","","","","","","","","","","","","","","")
//PutSx1(cPerg,"04","Cliente at?"          ,'','',"mv_ch4","C",6,0,0,"G","","SZ9","","S","mv_par04","","","","","","","","","","","","","","","","")

//Ŀ
//Definicoes/preparacao para impressao      
// 

ReportDef()   			 //Nesta funo nos definimos a estrutura do relatrio, por exemplo as sees, campos, totalizadores e etc.
oReport	:PrintDialog()	//PRINTDIALOG- Essa funo serve para disparar a impresso do TReport,  ela que faz com que seja 
						//exibida a tela de configurao de impressora e os botes de parmetros.
Return Nil
/*


ͻ
Programa  ReportDef Autor   Cludio Duarte    Data  27/07/2016	  
͹
Desc.      Definio da estrutura do relatrio.                       
                                                                      
͹
Uso                                                                   
ͼ


*/
Static Function ReportDef()

oReport := TReport():New("RESTRC01","Relao de itens a fracionar",cPerg,{|oReport| PrintReport(oReport)},"Impresso de relao de itens a fracionar.")
oReport:SetLandscape(.T.)   //SetLandscape:Define a orientao de pgina do relatrio como paisagem

/*
oReport-serve para controle do relatrio, carregamos tambm a varivel.
oSecCab-serve para controle da seo.
TRCell - serve para adicionar novos campos na seo.
*/
oSecCab := TRSection():New( oReport , "Relao de itens a fracionar", {"QRY"} )
TRCell():New( oSecCab, "UB_FILIAL"     	, "QRY")
TRCell():New( oSecCab, "UB_PRODUTO"    	, "QRY")
TRCell():New( oSecCab, "B1_DESC"    , "QRY")
TRCell():New( oSecCab, "B1_DESC"		, "QRY")
TRCell():New( oSecCab, "ABERTO"   	 , "QRY")
TRCell():New( oSecCab, "SALDO ARM 01"    , "QRY")
TRCell():New( oSecCab, "SALDO ARM02"    , "QRY")
  	
//TRFunction -  um totalizador,
// Onde:
//lEndSection Imprime o totalizador na quebra de seo se .T. 
//lEndReport   Imprime o totalizador no final do relatrio se .T. 
//lEndPage     Imprime o totalizador no final de cada pgina se .T. 


//TRFunction():New(/*Cell*/             ,/*cId*/,/*Function*/,/*oBreak*/,/*cTitle*/,/*cPicture*/,/*uFormula*/,/*lEndSection*/,/*lEndReport*/,/*lEndPage*/,/*Section*/)
//TRFunction():New(oSecCab:Cell("Z9_HORATOT"),"total horas","TIMESUM"     ,/*oBreak*/,/*cTitle*/,"@E 999:99",/*uFormula*/,.F.           ,.T.           ,.F.        ,oSecCab)


Return Nil
/*


ͻ
Programa  RESTRC01   Autor   Cludio Duarte    Data  27/07/2016	  
͹
Desc.           	  BUSCA DOS REGISTROS QUE DEVERO SER IMPRESSOS   
                                                                      
͹
Uso                                                                   
ͼ


*/
Static Function PrintReport(oReport)

Local cQuery     := ""
Local cUsrLog    := RetCodUsr()
Pergunte(cPerg,.F.)       

cQuery := "WITH ORCAMENTO AS " + CRLF
cQuery += " (SELECT UA_STATUS,UB_FILIAL,UB_NUM,UB_ITEM,UB_PRODUTO,UB_QUANT,ISNULL(C6_QTDVEN,0) AS C6_QTDVEN, " + CRLF
cQuery += " ISNULL(C6_QTDENT,0) AS C6_QTDENT,ISNULL(SUM(C9_QTDLIB),0) AS C9_QTDLIB" + CRLF
cQuery += "FROM SUB010 AS SUB " +CRLF         
cQuery += " INNER JOIN SUA010 AS SUA ON (UA_FILIAL = UB_FILIAL AND UA_NUM = UB_NUM AND SUA.D_E_L_E_T_ = '') " + CRLF
cQuery += " LEFT JOIN SC6010 AS SC6 ON (SC6.D_E_L_E_T_ = '' AND C6_NUM = UB_NUMPV AND C6_ITEM = UB_ITEMPV AND C6_FILIAL = UB_FILIAL) " + CRLF
cQuery += " LEFT JOIN SC9010 AS SC9 ON (SC9.D_E_L_E_T_ = '' AND C9_PEDIDO = C6_NUM AND C9_ITEM = C6_ITEM AND C9_FILIAL = C6_FILIAL AND C9_BLEST NOT IN ('','10')) " + CRLF
cQuery += " WHERE SUB.D_E_L_E_T_ = '' " + CRLF
cQuery += " AND UB_QUANT-ISNULL(C6_QTDENT,0)-ISNULL(C9_QTDLIB,0) > 0 " + CRLF
cQuery += " AND UA_EMISSAO BETWEEN  '" + Dtos(mv_par01) + "' AND '" + Dtos(mv_par02) + "' " + CRLF        
cQuery += " AND UA_STATUS NOT IN ('CAN','NF.') " + CRLF
cQuery += " GROUP BY UA_STATUS,UB_FILIAL,UB_NUM,UB_ITEM,UB_PRODUTO,UB_QUANT,C6_QTDVEN,C6_QTDENT ) " + CRLF

cQuery += " SELECT UB_FILIAL,UB_PRODUTO,B1_DESC,SUM(UB_QUANT-C6_QTDENT-C9_QTDLIB) AS ABERTO, " + CRLF
cQuery += " ISNULL((SELECT B2_QATU-B2_RESERVA FROM SB2010 AS SB2 WHERE SB2.D_E_L_E_T_ = '' AND B2_LOCAL = '01' AND B2_COD = UB_PRODUTO AND B2_FILIAL = UB_FILIAL),0) AS SALDO_01, " + CRLF
cQuery += " ISNULL((SELECT B2_QATU-B2_RESERVA FROM SB2010 AS SB2 WHERE SB2.D_E_L_E_T_ = '' AND B2_LOCAL = '02' AND B2_COD = UB_PRODUTO AND B2_FILIAL = UB_FILIAL),0) AS SALDO_02 " + CRLF
cQuery += "FROM ORCAMENTO " + CRLF
cQuery += " INNER JOIN SB1010 AS SB1 ON (SB1.D_E_L_E_T_ = '' AND B1_COD = UB_PRODUTO) " + CRLF
cQuery += " WHERE " + CRLF
cQuery += " ISNULL((SELECT B2_QATU-B2_RESERVA FROM SB2010 AS SB2 WHERE SB2.D_E_L_E_T_ = '' AND B2_LOCAL = '01' AND B2_COD = UB_PRODUTO AND B2_FILIAL = UB_FILIAL),0) > 0 " + CRLF
cQuery += " GROUP BY UB_FILIAL,UB_PRODUTO,B1_DESC "+ CRLF
cQuery += " HAVING SUM(UB_QUANT-C6_QTDENT-C9_QTDLIB)> ISNULL((SELECT B2_QATU-B2_RESERVA FROM SB2010 AS SB2 WHERE SB2.D_E_L_E_T_ = '' AND B2_LOCAL = '02' AND B2_COD = UB_PRODUTO AND B2_FILIAL = UB_FILIAL),0) "+ CRLF
cQuery += " ORDER BY 1 " + CRLF

//cQuery := ChangeQuery(cQuery)
/*

 
	cQuery = " SELECT " + CRLF						//"" - esta recebendo como se fosse uma texto de qry por isso o sinal
	cQuery += " SZ9.Z9_DATA, " 	  + CRLF
	cQuery += " SZ9.Z9_NOMECON, " + CRLF
	cQuery += " SZ9.Z9_CLIENTE, " + CRLF
	cQuery += " SA1.A1_NOME, "    + CRLF
	cQuery += " SZ9.Z9_CODOS, "   + CRLF
	cQuery += " SZ9.Z9_HORAINI, " + CRLF
	cQuery += " SZ9.Z9_HORAFIM, " + CRLF
	cQuery += " SZ9.Z9_HORATRA, " + CRLF
	cQuery += " SZ9.Z9_HORAALM, " + CRLF
	cQuery += " SZ9.Z9_HORATOT, " + CRLF
	cQuery += " SZ9.Z9_TPOS     " + CRLF
	cQuery += " FROM " + RetSqlName("SZ9") + " SZ9 " + CRLF
	cQuery += " INNER JOIN SA1990 SA1 ON SA1.A1_COD = SZ9.Z9_CLIENTE" + CRLF  // ele relaciona com outra tabela no caso da sa1
	cQuery += " WHERE SZ9.Z9_FILIAL = '" + xFilial ("SZ9") + "' " + CRLF
	cQuery += " AND SZ9.Z9_CODCONS = '" + cUsrLog + "' " + CRLF
	cQuery += " AND SZ9.Z9_DATA BETWEEN    '" + Dtos(mv_par01) + "' AND '" + Dtos(mv_par02) + "' " + CRLF
	cQuery += " AND SZ9.Z9_CLIENTE BETWEEN '" + mv_par03 + "' AND '" + mv_par04 + "' " + CRLF
	cQuery += " AND SZ9.D_E_L_E_T_ = ' ' " + CRLF
	cQuery += " ORDER BY SZ9.Z9_DATA,SZ9.Z9_CLIENTE,SZ9.Z9_CODOS " + CRLF				//ORDER BY- ordena o relatorio por ordem crescente de data.
*/	

//TcSetField( "CLI", "Z9_DATA", "D" )	


If Select("QRY") > 0  // SELECT TRAZ A AREA DE TRABALHO EM VALOR NUMRICO, SE NO EXISTE TRAZ ZERO. 
					// Nesse caso, se ele existir , logo ser qualquer nmero de 0 a 250 e portando deve se fechar ele.
	Dbselectarea("QRY")
	QRY->(DbClosearea())  // s funciona no alias ativo na conexo, logo  necessrio estar junto do dbselectarea 
						 //que faz a abertura.
	
EndIf

PlsQuery(cQuery,"QRY")

oReport:Section("Relao de itens a fracionar"):Init()
While QRY->(!Eof())
	oReport:Section("Relao de itens a fracionar"):PrintLine()
	QRY->(dbSkip())
EndDo
oReport:Section("Relao de itens a fracionar"):Finish()
QRY->(dbCloseArea())
//DbUseArea(.T.,"TOPCONN",TcGenQry(,,ChangeQuery(cQuery)),"QRY",.T.,.T.)     // Aqui eu fao o tratamento para apresentar a data
 //	TcSetField( "QRY", "Z9_DATA", "D" )										// em formato dia/mes/ano
																			//TcSetField - Altera o tratamento, do tipo de dado ou preciso, 
																			//para um campo/coluna retornada atravs de uma query.
//TcQuery cQuery New Alias "QRY"

/*oSecCab:BeginQuery()
oSecCab:EndQuery({{"QRY"},cQuery})    
oSecCab:Print()*/

Return


